Index: palm/trunk/SOURCE/plant_canopy_model.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model.f90	(revision 1483)
+++ palm/trunk/SOURCE/plant_canopy_model.f90	(revision 1484)
@@ -204,20 +624,23 @@
                 DO  j = nys, nyn
                    DO  k = nzb_s_inner(j,i)+1, pch_index
-                      tend(k,j,i) = tend(k,j,i) -                     &
-                                    2.0_wp * cdc(k,j,i) * lad_s(k,j,i) * &
-                                    SQRT( ( ( u(k,j,i)              + &
-                                              u(k,j,i+1) )            &
-                                            / 2.0_wp )**2           + &
-                                          ( ( v(k,j,i)              + &
-                                              v(k,j+1,i) )            &
-                                            / 2.0_wp )**2           + &
-                                          ( ( w(k,j,i)              + &
-                                              w(k+1,j,i) )            &
-                                            / 2.0_wp )**2 )         * &
-                                    e(k,j,i)
+                      tend(k,j,i) = tend(k,j,i) -                              &
+                                       2.0_wp * cdc *                          &
+                                       lad_s(k,j,i) *                          &
+                                       SQRT( ( 0.5_wp * ( u(k,j,i) +           &
+                                                          u(k,j,i+1) )         &
+                                             )**2 +                            &
+                                             ( 0.5_wp * ( v(k,j,i) +           &
+                                                          v(k,j+1,i) )         &
+                                             )**2 +                            &
+                                             ( 0.5_wp * ( w(k,j,i) +           &
+                                                          w(k+1,j,i) )         &
+                                             )**2                              &
+                                           ) *                                 &
+                                       e(k,j,i)
                    ENDDO
                 ENDDO
              ENDDO 
-                        
+
+
           CASE DEFAULT
 
@@ -231,18 +654,32 @@
 
 !------------------------------------------------------------------------------!
-! Call for grid point i,j
+! Description:
+! ------------
+!-- Calculation of the tendency terms, accounting for the effect of the plant
+!-- canopy on momentum and scalar quantities.
+!--
+!-- The canopy is located where the leaf area density lad_s(k,j,i) > 0.0 
+!-- (defined on scalar grid), as initialized in subroutine init_plant_canopy. 
+!-- The lad on the w-grid is vertically interpolated from the surrounding
+!-- lad_s. The upper boundary of the canopy is defined on the w-grid at 
+!-- k = pch_index. Here, the lad is zero.
+!--
+!-- The canopy drag must be limited (previously accounted for by calculation of 
+!-- a limiting canopy timestep for the determination of the maximum LES timestep
+!-- in subroutine timestep), since it is physically impossible that the canopy
+!-- drag alone can locally change the sign of a velocity component. This 
+!-- limitation is realized by calculating preliminary tendencies and velocities.
+!-- It is subsequently checked if the preliminary new velocity has a different
+!-- sign than the current velocity. If so, the tendency is limited in a way that
+!-- the velocity can at maximum be reduced to zero by the canopy drag. 
+!--
+!--
+!-- Call for grid point i,j
 !------------------------------------------------------------------------------!
     SUBROUTINE plant_canopy_model_ij( i, j, component )
 
-       USE arrays_3d,                                                          &
-           ONLY:  canopy_heat_flux, cdc, dzw, e, lad_s, lad_u, lad_v, lad_w,   &
-                  q, sec, sls, tend, u, v, w
 
        USE control_parameters,                                                 &
-           ONLY:  pch_index, message_string
-
-       USE indices,                                                            &
-           ONLY:  nxl, nxlu, nxr, nys, nysv, nyn, nzb_s_inner, nzb_u_inner,    &
-                  nzb_v_inner, nzb_w_inner
+           ONLY:  dt_3d, message_string
 
        USE kinds
@@ -250,73 +687,175 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  component  !:
-       INTEGER(iwp) ::  i          !:
-       INTEGER(iwp) ::  j          !:
-       INTEGER(iwp) ::  k          !:
-
-!
-!--    Compute drag for the three velocity components
+       INTEGER(iwp) ::  component !: prognostic variable (u,v,w,pt,q,e)
+       INTEGER(iwp) ::  i         !: running index
+       INTEGER(iwp) ::  j         !: running index
+       INTEGER(iwp) ::  k         !: running index
+
+       REAL(wp) ::  ddt_3d    !: inverse of the LES timestep (dt_3d)
+       REAL(wp) ::  lad_local !: local lad value
+       REAL(wp) ::  pre_tend  !: preliminary tendency
+       REAL(wp) ::  pre_u     !: preliminary u-value 
+       REAL(wp) ::  pre_v     !: preliminary v-value 
+       REAL(wp) ::  pre_w     !: preliminary w-value 
+
+
+       ddt_3d = 1.0_wp / dt_3d
+
+!
+!--    Compute drag for the three velocity components and the SGS-TKE
        SELECT CASE ( component )
 
 !
 !--       u-component
-       CASE ( 1 )
-          DO  k = nzb_u_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                     &
-                              cdc(k,j,i) * lad_u(k,j,i) *    &   
-                              SQRT(     u(k,j,i)**2 +        &
-                                    ( ( v(k,j,i-1)  +        &
-                                        v(k,j,i)    +        &
-                                        v(k,j+1,i)  +        &
-                                        v(k,j+1,i-1) )       &
-                                      / 4.0_wp )**2 +        &
-                                    ( ( w(k-1,j,i-1) +       &
-                                        w(k-1,j,i)   +       &
-                                        w(k,j,i-1)   +       &
-                                        w(k,j,i) )           &
-                                      / 4.0_wp )**2 ) *      &
-                              u(k,j,i)
-          ENDDO
+          CASE ( 1 )
+             DO  k = nzb_u_inner(j,i)+1, pch_index
+
+!
+!--             In order to create sharp boundaries of the plant canopy, 
+!--             the lad on the u-grid at index (k,j,i) is equal to lad_s(k,j,i),
+!--             rather than being interpolated from the surrounding lad_s, 
+!--             because this would yield smaller lad at the canopy boundaries 
+!--             than inside of the canopy.
+!--             For the same reason, the lad at the rightmost(i+1)canopy 
+!--             boundary on the u-grid equals lad_s(k,j,i).
+                lad_local = lad_s(k,j,i)
+                IF ( lad_local == 0.0_wp  .AND.                                &
+                     lad_s(k,j,i-1) > 0.0_wp )  THEN
+                   lad_local = lad_s(k,j,i-1)
+                ENDIF
+
+                pre_tend = 0.0_wp
+                pre_u = 0.0_wp
+!
+!--             Calculate preliminary value (pre_tend) of the tendency
+                pre_tend = - cdc *                                             &
+                             lad_local *                                       &   
+                             SQRT( u(k,j,i)**2 +                               &
+                                   ( 0.25_wp * ( v(k,j,i-1)  +                 &
+                                                 v(k,j,i)    +                 &
+                                                 v(k,j+1,i)  +                 &
+                                                 v(k,j+1,i-1) )                &
+                                   )**2 +                                      &
+                                   ( 0.25_wp * ( w(k-1,j,i-1) +                &
+                                                 w(k-1,j,i)   +                &
+                                                 w(k,j,i-1)   +                &
+                                                 w(k,j,i) )                    &
+                                   )**2                                        &
+                                 ) *                                           &
+                             u(k,j,i)
+
+!
+!--             Calculate preliminary new velocity, based on pre_tend
+                pre_u = u(k,j,i) + dt_3d * pre_tend
+!
+!--             Compare sign of old velocity and new preliminary velocity,
+!--             and in case the signs are different, limit the tendency
+                IF ( SIGN(pre_u,u(k,j,i)) /= pre_u )  THEN
+                   pre_tend = - u(k,j,i) * ddt_3d
+                ELSE
+                   pre_tend = pre_tend
+                ENDIF
+!
+!--             Calculate final tendency
+                tend(k,j,i) = tend(k,j,i) + pre_tend
+             ENDDO
+
 
 !
 !--       v-component
-       CASE ( 2 )
-          DO  k = nzb_v_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                     &
-                              cdc(k,j,i) * lad_v(k,j,i) *    &
-                              SQRT( ( ( u(k,j-1,i)   +       &
-                                        u(k,j-1,i+1) +       &
-                                        u(k,j,i)     +       &
-                                        u(k,j,i+1) )         &
-                                      / 4.0_wp )**2  +       &
-                                        v(k,j,i)**2  +       &
-                                    ( ( w(k-1,j-1,i) +       &
-                                        w(k-1,j,i)   +       &
-                                        w(k,j-1,i)   +       &
-                                        w(k,j,i) )           &
-                                      / 4.0_wp )**2 ) *      &
-                              v(k,j,i)
-          ENDDO
+          CASE ( 2 )
+             DO  k = nzb_v_inner(j,i)+1, pch_index
+
+!
+!--             In order to create sharp boundaries of the plant canopy, 
+!--             the lad on the v-grid at index (k,j,i) is equal to lad_s(k,j,i),
+!--             rather than being interpolated from the surrounding lad_s, 
+!--             because this would yield smaller lad at the canopy boundaries 
+!--             than inside of the canopy.
+!--             For the same reason, the lad at the northmost(j+1)canopy 
+!--             boundary on the v-grid equals lad_s(k,j,i).
+                lad_local = lad_s(k,j,i)
+                IF ( lad_local == 0.0_wp  .AND.                                &
+                     lad_s(k,j-1,i) > 0.0_wp )  THEN
+                   lad_local = lad_s(k,j-1,i)
+                ENDIF
+
+                pre_tend = 0.0_wp
+                pre_v = 0.0_wp
+!
+!--             Calculate preliminary value (pre_tend) of the tendency
+                pre_tend = - cdc *                                             &
+                             lad_local *                                       &
+                             SQRT( ( 0.25_wp * ( u(k,j-1,i)   +                &
+                                                 u(k,j-1,i+1) +                &
+                                                 u(k,j,i)     +                &
+                                                 u(k,j,i+1) )                  &
+                                   )**2 +                                      &
+                                   v(k,j,i)**2 +                               &
+                                   ( 0.25_wp * ( w(k-1,j-1,i) +                &
+                                                 w(k-1,j,i)   +                &
+                                                 w(k,j-1,i)   +                &
+                                                 w(k,j,i) )                    &
+                                   )**2                                        &
+                                 ) *                                           &
+                             v(k,j,i)
+
+!
+!--             Calculate preliminary new velocity, based on pre_tend
+                pre_v = v(k,j,i) + dt_3d * pre_tend
+!
+!--             Compare sign of old velocity and new preliminary velocity,
+!--             and in case the signs are different, limit the tendency
+                IF ( SIGN(pre_v,v(k,j,i)) /= pre_v )  THEN
+                   pre_tend = - v(k,j,i) * ddt_3d
+                ELSE
+                   pre_tend = pre_tend
+                ENDIF
+!
+!--             Calculate final tendency
+                tend(k,j,i) = tend(k,j,i) + pre_tend
+             ENDDO
+
 
 !
 !--       w-component
-       CASE ( 3 )
-          DO  k = nzb_w_inner(j,i)+1, pch_index
-             tend(k,j,i) = tend(k,j,i) -                     &
-                              cdc(k,j,i) * lad_w(k,j,i) *    & 
-                              SQRT( ( ( u(k,j,i)    +        &  
-                                        u(k,j,i+1)  +        &
-                                        u(k+1,j,i)  +        &
-                                        u(k+1,j,i+1) )       &
-                                      / 4.0_wp )**2 +        &
-                                    ( ( v(k,j,i)    +        &
-                                        v(k,j+1,i)  +        &
-                                        v(k+1,j,i)  +        &
-                                        v(k+1,j+1,i) )       &
-                                      / 4.0_wp )**2 +        &
-                                        w(k,j,i)**2 ) *      &
-                              w(k,j,i)
-   
-          ENDDO
+          CASE ( 3 )
+             DO  k = nzb_w_inner(j,i)+1, pch_index-1
+
+                pre_tend = 0.0_wp
+                pre_w = 0.0_wp
+!
+!--             Calculate preliminary value (pre_tend) of the tendency
+                pre_tend = - cdc *                                             &
+                             (0.5_wp *                                         &
+                                ( lad_s(k+1,j,i) + lad_s(k,j,i) )) *           &
+                             SQRT( ( 0.25_wp * ( u(k,j,i)    +                 &  
+                                                 u(k,j,i+1)  +                 &
+                                                 u(k+1,j,i)  +                 &
+                                                 u(k+1,j,i+1) )                &
+                                   )**2 +                                      &
+                                   ( 0.25_wp * ( v(k,j,i)    +                 &
+                                                 v(k,j+1,i)  +                 &
+                                                 v(k+1,j,i)  +                 &
+                                                 v(k+1,j+1,i) )                &
+                                   )**2 +                                      &
+                                   w(k,j,i)**2                                 &
+                                 ) *                                           &
+                             w(k,j,i)
+!
+!--             Calculate preliminary new velocity, based on pre_tend
+                pre_w = w(k,j,i) + dt_3d * pre_tend
+!
+!--             Compare sign of old velocity and new preliminary velocity,
+!--             and in case the signs are different, limit the tendency
+                IF ( SIGN(pre_w,w(k,j,i)) /= pre_w )  THEN
+                   pre_tend = - w(k,j,i) * ddt_3d
+                ELSE
+                   pre_tend = pre_tend
+                ENDIF
+!
+!--             Calculate final tendency
+                tend(k,j,i) = tend(k,j,i) + pre_tend
+             ENDDO
 
 !
@@ -324,8 +863,7 @@
           CASE ( 4 )
              DO  k = nzb_s_inner(j,i)+1, pch_index
-                tend(k,j,i) = tend(k,j,i) +                   &
-                              ( canopy_heat_flux(k,j,i) -     &
-                                canopy_heat_flux(k-1,j,i) ) / &
-                                dzw(k)
+                tend(k,j,i) = tend(k,j,i) +                                    &
+                                 ( canopy_heat_flux(k,j,i) -                   &
+                                   canopy_heat_flux(k-1,j,i) ) / dzw(k)
              ENDDO
 
@@ -335,35 +873,39 @@
           CASE ( 5 )
              DO  k = nzb_s_inner(j,i)+1, pch_index
-                tend(k,j,i) = tend(k,j,i) -                     &
-                              sec(k,j,i) * lad_s(k,j,i) *       &
-                              SQRT( ( ( u(k,j,i)        +       &
-                                        u(k,j,i+1) )            &
-                                      / 2.0_wp )**2     +       &
-                                    ( ( v(k,j,i)        +       &
-                                        v(k,j+1,i) )            &
-                                      / 2.0_wp )**2     +       &
-                                    ( ( w(k-1,j,i)      +       &
-                                        w(k,j,i) )              &
-                                      / 2.0_wp )**2 )   *       &
-                              ( q(k,j,i) - sls(k,j,i) )
+                tend(k,j,i) = tend(k,j,i) -                                    &
+                                 lsec *                                        &
+                                 lad_s(k,j,i) *                                &
+                                 SQRT( ( 0.5_wp * ( u(k,j,i) +                 &
+                                                    u(k,j,i+1) )               &
+                                       )**2  +                                 &
+                                       ( 0.5_wp * ( v(k,j,i) +                 &
+                                                    v(k,j+1,i) )               &
+                                       )**2 +                                  &
+                                       ( 0.5_wp * ( w(k-1,j,i) +               &
+                                                    w(k,j,i) )                 &
+                                       )**2                                    &
+                                     ) *                                       &
+                                 ( q(k,j,i) - lsc )
              ENDDO   
 
 !
 !--       sgs-tke
-       CASE ( 6 )
-          DO  k = nzb_s_inner(j,i)+1, pch_index   
-             tend(k,j,i) = tend(k,j,i) -                        &
-                              2.0_wp * cdc(k,j,i) * lad_s(k,j,i) * &
-                              SQRT( ( ( u(k,j,i)           +    &
-                                        u(k,j,i+1) )            &
-                                      / 2.0_wp )**2        +    &  
-                                    ( ( v(k,j,i)           +    &
-                                        v(k,j+1,i) )            &
-                                      / 2.0_wp )**2        +    &
-                                    ( ( w(k,j,i)           +    &
-                                        w(k+1,j,i) )            &
-                                      / 2.0_wp )**2 )      *    &
-                              e(k,j,i)
-          ENDDO
+          CASE ( 6 )
+             DO  k = nzb_s_inner(j,i)+1, pch_index   
+                tend(k,j,i) = tend(k,j,i) -                                    &
+                                 2.0_wp * cdc *                                &
+                                 lad_s(k,j,i) *                                &
+                                 SQRT( ( 0.5_wp * ( u(k,j,i) +                 &
+                                                    u(k,j,i+1) )               &
+                                       )**2 +                                  &  
+                                       ( 0.5_wp * ( v(k,j,i) +                 &
+                                                    v(k,j+1,i) )               &
+                                       )**2 +                                  &
+                                       ( 0.5_wp * ( w(k,j,i) +                 &
+                                                    w(k+1,j,i) )               &
+                                       )**2                                    &
+                                     ) *                                       &
+                                 e(k,j,i)
+             ENDDO
 
        CASE DEFAULT
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1483)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1484)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   parameters cthf and plant_canopy moved to module plant_canopy_model_mod.
+! Removed double-listing of use_upstream_for_tke in ONLY-list of module
+! control_parameters
 ! 
 ! Former revisions:
@@ -163,15 +166,15 @@
     USE control_parameters,                                                    &
         ONLY:  call_microphysics_at_all_substeps, cloud_physics,               &
-               constant_diffusion, cthf, dp_external,                          &
+               constant_diffusion, dp_external,                                &
                dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d, humidity,       &
                icloud_scheme, inflow_l, intermediate_timestep_count,           &
                intermediate_timestep_count_max, large_scale_forcing,           &
                large_scale_subsidence, neutral, nudging, ocean, outflow_l,     &
-               outflow_s, passive_scalar, plant_canopy, precipitation,         &
+               outflow_s, passive_scalar, precipitation,                       &
                prho_reference, prho_reference, prho_reference, pt_reference,   &
                pt_reference, pt_reference, radiation, scalar_advec,            &
                scalar_advec, simulated_time, sloping_surface, timestep_scheme, &
                tsc, use_subsidence_tendencies, use_upstream_for_tke,           &
-               use_upstream_for_tke, use_upstream_for_tke, wall_heatflux,      &
+               wall_heatflux,                                                  &
                wall_nrflux, wall_qflux, wall_qflux, wall_qflux, wall_qrflux,   &
                wall_salinityflux, ws_scheme_mom, ws_scheme_sca
@@ -257,5 +260,5 @@
 
     USE plant_canopy_model_mod,                                                &
-        ONLY:  plant_canopy_model
+        ONLY:  cthf, plant_canopy, plant_canopy_model
 
     USE production_e_mod,                                                      &
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1483)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1484)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! Changes in the course of the canopy-model modularization:
+!   parameters alpha_lad, beta_lad, lai_beta added,
+!   module plant_canopy_model_mod added,
+!   drag_coefficient, leaf_surface_concentration and scalar_exchange_coefficient
+!   renamed to canopy_drag_coeff, leaf_surface_conc and leaf_scalar_exch_coeff
 !
 ! Former revisions:
@@ -117,5 +121,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  inflow_damping_factor, lad, mean_inflow_profiles, pt_init,      &
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
                q_init, ref_state, sa_init, u_init, ug, v_init, vg
 
@@ -141,4 +145,11 @@
 
     USE pegrid
+
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  alpha_lad, beta_lad, canopy_drag_coeff, canopy_mode, cthf, lad, &
+               lad_surface, lad_vertical_gradient, lad_vertical_gradient_level,&
+               lad_vertical_gradient_level_ind,                                &
+               lai_beta, leaf_scalar_exch_coeff, leaf_surface_conc, pch_index, &
+               plant_canopy
 
     USE statistics,                                                            &
@@ -242,4 +253,6 @@
           CASE ( 'advected_distance_y' )
              READ ( 13 )  advected_distance_y
+          CASE ( 'alpha_lad' )
+             READ ( 13 )  alpha_lad
           CASE ( 'alpha_surface' )
              READ ( 13 )  alpha_surface
@@ -282,4 +295,6 @@
           CASE ( 'bc_uv_t' )
              READ ( 13 )  bc_uv_t
+          CASE ( 'beta_lad' )
+             READ ( 13 )  beta_lad
           CASE ( 'bottom_salinityflux' )
              READ ( 13 )  bottom_salinityflux
@@ -296,4 +311,6 @@
           CASE ( 'call_psolver_at_all_substeps' )
              READ ( 13 )  call_psolver_at_all_substeps
+          CASE ( 'canopy_drag_coeff' )
+             READ ( 13 )  canopy_drag_coeff
           CASE ( 'canopy_mode' )
              READ ( 13 )  canopy_mode
@@ -354,6 +371,4 @@
           CASE ( 'dpdxy' )
              READ ( 13 )  dpdxy
-          CASE ( 'drag_coefficient' )
-             READ ( 13 )  drag_coefficient
           CASE ( 'drizzle' )
              READ ( 13 )  drizzle
@@ -419,10 +434,14 @@
           CASE ( 'lad_vertical_gradient_level_in' )
              READ ( 13 )  lad_vertical_gradient_level_ind
+          CASE ( 'lai_beta' )
+             READ ( 13 )  lai_beta
           CASE ( 'large_scale_forcing' )
              READ ( 13 )  large_scale_forcing
            CASE ( 'large_scale_subsidence' )
              READ ( 13 )  large_scale_subsidence
-          CASE ( 'leaf_surface_concentration' )
-             READ ( 13 )  leaf_surface_concentration
+          CASE ( 'leaf_scalar_exch_coeff' )
+             READ ( 13 )  leaf_scalar_exch_coeff
+          CASE ( 'leaf_surface_conc' )
+             READ ( 13 )  leaf_surface_conc
           CASE ( 'limiter_sedimentation' )
              READ ( 13 )  limiter_sedimentation
@@ -558,6 +577,4 @@
           CASE ( 'scalar_advec' )
              READ ( 13 )  scalar_advec
-          CASE ( 'scalar_exchange_coefficient' )
-             READ ( 13 )  scalar_exchange_coefficient
           CASE ( 'simulated_time' )
              READ ( 13 )  simulated_time
@@ -731,5 +748,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  inflow_damping_factor, lad, mean_inflow_profiles, pt_init,      &
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
                q_init, ref_state, sa_init, u_init, ug, v_init, vg
 
